<html>

<head>
      <title>Readme bij bibliotheekopdracht (DB module)</title>
      <style type='text/css'>
      pre    { color: navy;
               display: inline-block;
               margin-top: 0em;
               margin-bottom: 0em;
             }
      </style>
</head>

<body>
<p>
naam          : Pieter van Ede <br/>
login         : pjede          <br/>
studentnummer : 3019764
</p>

<b>Imports ed</b><br/>
Hier declareer ik dat dit Haskell-file de module BiblioDB is, zodat daar met
behulp van imports vanuit andere Haskell programma's naar verwezen kan worden.
De module Char importeer ik om functies waarmee ik numerieke strings (string die 
een getal representateerd) naar de bijbehorende Int-waarde kan converteren.
<pre>

> module BiblioDB where
> import Char

</pre>
<b>Definitie van datatypes</b><br/>
Hier definieer ik hoe de verschillende gegevens van de bibliotheek in de
bibliotheek "database" moeten worden opgeslagen. Dit spreekt vrij voor zich:
voor een lener sla ik lenersnummer, naam en adresgegevens op. Leners bevat een lijst
van alle mensen die bij deze bibliotheek mogen lenen. Bij boek sla ik boeknummer,
titel en ISBN-nummer op en in boeken sla ik een lijst met alle boeken in deze
bibliotheek op. Tevens zorg ik ervoor dat alles showable is, voornamelijk vanwege
debugredenen.
<pre>

> data Lener    = Lener Lenersnummer Voornaam Tussenvoegsel Achternaam Straat Huisnummer Postcode Woonplaats
>   deriving (Show, Eq)
> data Leners   = Leners [Lener]
>   deriving (Show, Eq)
> data Boek     = Boek Boeknummer Titel Auteur Genre ISBN
>   deriving (Show, Eq)
> data Boeken   = Boeken [Boek]
>   deriving (Show, Eq)
> data Lening   = Lening Boeknummer Lenersnummer Datum
>   deriving (Show, Eq)
> data Leningen = Leningen [Lening]
>   deriving (Show, Eq)

> data Datum    = Datum Dag Maand Jaar
>   deriving (Show, Eq)

</pre>
Vervolgens definieer ik op wat voor datatype (string, int, ...) de zojuist
gebruikte typen (Lenersnummer, Voornaam, ...) moeten hebben. Huisnummer moet
ook een string zijn, om adressen als 16A te kunnen opslaan.
<pre>

> type Lenersnummer  = Int
> type Voornaam      = String
> type Tussenvoegsel = String
> type Achternaam    = String
> type Straat        = String
> type Huisnummer    = String
> type Postcode      = String
> type Woonplaats    = String

> type Boeknummer = Int
> type Titel      = String
> type Auteur     = String
> type Genre      = String
> type ISBN       = String

> type Dag   = Int
> type Maand = Int
> type Jaar  = Int

</pre>
<b>Definitie updatefuncties</b></br>
Deze hieronder gedefinieerde functies kunnen de leners-, boeken- en leningenlijst
bijwerken. Dat betekent dus Leners, Boeken of Leningen bijwerken.
<br/><br/>
De functie maakLener voegt een lener toe, maar zorgt ervoor dat de lijst met leners
gesorteerd blijft en geen dubbelen bevat.
<pre>

> maakLener :: Leners -> Lenersnummer -> Voornaam -> Tussenvoegsel -> Achternaam
>     -> Straat -> Huisnummer -> Postcode -> Woonplaats -> Leners
> maakLener (Leners xs) lnr voorn tussenv achtern str huisnr postc woonpl
>   = Leners (voegInItem comparator (Lener lnr voorn tussenv achtern str huisnr postc woonpl) xs)
>      where
>        comparator (Lener lnr1 _ _ _ _ _ _ _) (Lener lnr2 _ _ _ _ _ _ _)
>          | lnr1 < lnr2 = True
>          | otherwise   = False

</pre>
Dit is een handige functie, die een item invoegt in een gesorteerde lijst, en
daarbij de sorteer middels de comparator handhaaft en er ook voor zorgt dat er
geen dubbelen in de lijst ontstaan. Daarvoor moet de comparator aan de eis voldoen
dat hij alleen True geeft als zijn eerste argument strikt kleiner is dan zijn
tweede argument. Dit is zo omdat als twee items gelijk zijn er toch False uitkomt
en er naar het einde van de lijst wordt gelopen zonder iets in te voegen.
<pre>

> voegInItem :: (a -> a -> Bool) -> a -> [a] -> [a]
> voegInItem comp item [] = [item]
> voegInItem comp item (x : xs) | comp item x = item : x : xs
>                               | otherwise   = x : (voegInItem comp item xs)

</pre>
De functie wijzigLener zoekt eerst de lezer met het gegeven Lenersnummer op, en
verandert vervolgens zijn data naar de gegeven data. Als de Lener niet
gevonden kan worden, dan gebeurt er helemaal niks.
<pre>

> wijzigLener :: Leners -> Lenersnummer -> Voornaam -> Tussenvoegsel -> Achternaam
>     -> Straat -> Huisnummer -> Postcode -> Woonplaats -> Leners
> wijzigLener (Leners []) _ _ _ _ _ _ _ _ = Leners []
> wijzigLener (Leners (Lener lnr1 voorn1 tussenv1 achtern1 str1 huisnr1 postc1 woonpl1 : xs))
>   lnr2 voorn2 tussenv2 achtern2 str2 huisnr2 postc2 woonpl2
>     | lnr1 == lnr2 = maakLener (Leners xs) lnr2 voorn2 tussenv2 achtern2 str2 huisnr2 postc2 woonpl2
>     | otherwise = maakLener (wijzigLener (Leners xs) lnr2 voorn2 tussenv2 achtern2 str2 huisnr2 postc2 woonpl2)
>         lnr1 voorn1 tussenv1 achtern1 str1 huisnr1 postc1 woonpl1

</pre>
En om het rijtje compleet te maken voor de Leners, hier een functie die een lener met
een gegeven Lenersnummer verwijdert. Ook hier geldt: als de Lener niet gevonden wordt,
dan gebeurt er helemaal niks.
<pre>

> verwijderLener :: Leners -> Lenersnummer -> Leners
> verwijderLener (Leners []) _ = Leners []
> verwijderLener (Leners (Lener lnr1 voorn tussenv achtern str huisnr postc woonpl : xs)) lnr2
>     | lnr1 == lnr2 = Leners xs
>     | otherwise = maakLener (verwijderLener (Leners xs) lnr2) lnr1 voorn tussenv achtern str huisnr postc woonpl

</pre>
Nu komen dezelfde functies, maar dan voor boeken. Ik ga ze niet weer toelichten, 
want ze zien er hetzelfde uit als die van Leners.
<pre>

> maakBoek :: Boeken -> Boeknummer -> Titel -> Auteur -> Genre -> ISBN -> Boeken
> maakBoek (Boeken xs) bnr titel auteur genre isbn
>  = Boeken (voegInItem comparator (Boek bnr titel auteur genre isbn) xs)
>      where
>        comparator (Boek bnr1 _ _ _ _) (Boek bnr2 _ _ _ _)
>          | bnr1 < bnr2 = True
>          | otherwise   = False

> wijzigBoek :: Boeken -> Boeknummer -> Titel -> Auteur -> Genre -> ISBN -> Boeken
> wijzigBoek (Boeken []) _ _ _ _ _ = Boeken []
> wijzigBoek (Boeken (Boek bnr1 titel1 aut1 genre1 isbn1 : xs)) bnr2 titel2 aut2 genre2 isbn2
>     | bnr1 == bnr2 = maakBoek (Boeken xs) bnr2 titel2 aut2 genre2 isbn2
>     | otherwise = maakBoek (wijzigBoek (Boeken xs) bnr2 titel2 aut2 genre2 isbn2) bnr1 titel1 aut1 genre1 isbn1

> verwijderBoek :: Boeken -> Boeknummer -> Boeken
> verwijderBoek (Boeken []) _ = Boeken []
> verwijderBoek (Boeken (Boek bnr1 titel aut genre isbn : xs)) bnr2
>     | bnr1 == bnr2 = Boeken xs
>     | otherwise = maakBoek (verwijderBoek (Boeken xs) bnr2) bnr1 titel aut genre isbn

</pre>
En dan nogmaals dezelfde functies voor Leningen...
<pre>

> maakLening :: Leningen -> Boeknummer -> Lenersnummer -> Datum -> Leningen
> maakLening (Leningen xs) bnr lnr datum = Leningen (Lening bnr lnr datum : xs)

> wijzigLening :: Leningen -> Boeknummer -> Lenersnummer -> Datum -> Leningen
> wijzigLening (Leningen []) _ _ _ = Leningen []
> wijzigLening (Leningen (Lening bnr1 lnr1 datum1 : xs)) bnr2 lnr2 datum2
>     | bnr1 == bnr2 && lnr1 == lnr2 = maakLening (Leningen xs) bnr2 lnr2 datum2
>     | otherwise = maakLening (wijzigLening (Leningen xs) bnr2 lnr2 datum2) bnr1 lnr1 datum1

> verwijderLening :: Leningen -> Boeknummer -> Lenersnummer -> Leningen
> verwijderLening (Leningen []) _ _ = Leningen []
> verwijderLening (Leningen (Lening bnr1 lnr1 datum1 : xs)) bnr2 lnr2
>     | bnr1 == bnr2 && lnr1 == lnr2 = Leningen xs
>     | otherwise = maakLening (verwijderLening (Leningen xs) bnr2 lnr2) bnr1 lnr1 datum1

</pre>
<b>Definitie van zoekfuncties</b><br/>
De hierna gedefinieerde zoekfuncties gaan allen op dezelfde manier: ze zoeken
de lijst van Leners, Boeken of Leningen af mbv de basisfunctie zoekIets die werkt
naar analogie van de functie elemBy uit de Helium prelude. <br/>
De functie zoekIets loopt een lijst af en test of een element voldoet aan een eis,
en retourneert dat element vervolgens.
<pre>

> zoekIets :: (a -> b -> Bool) -> b -> [a] -> Maybe a
> zoekIets _ _ [] = Nothing
> zoekIets foo key (x : xs) | foo x key = Just x
>                           | otherwise = zoekIets foo key xs

</pre>
Vervolgens maken de zoekfuncties voor Leners, Boeken en Leningen dankbaar 
gebruik van deze polymorfe functie, en definieren de vergelijkingsfunctie
foo steeds z, dat hij de (in database-termen) primary key vergelijkt met de
gegeven key. Dat is bij Leners het Lenersnummer, bij Boeken het Boeknummer en
bij Leningen de combinatie daarvan.
<pre>

> zoekLener :: Leners -> Lenersnummer -> Maybe Lener
> zoekLener (Leners xs) lnr = zoekIets foo lnr xs
>   where
>     foo (Lener lnr1 _ _ _ _ _ _ _) lnr2
>        | lnr1 == lnr2 = True
>        | otherwise    = False

> zoekBoek :: Boeken -> Boeknummer -> Maybe Boek
> zoekBoek (Boeken xs) bnr = zoekIets foo bnr xs
>   where
>     foo (Boek bnr1 _ _ _ _) bnr2
>        | bnr1 == bnr2 = True
>        | otherwise    = False

> zoekLening :: Leningen -> Boeknummer -> Lenersnummer -> Maybe Lening
> zoekLening (Leningen xs) bnr lnr = zoekIets foo (bnr, lnr) xs
>   where
>     foo (Lening bnr1 lnr1 _) (bnr2, lnr2)
>        | lnr1 == lnr2 = True
>        | otherwise    = False

</pre>
<b>Handige functies</b><br/>
De functie lenerNummers extraheert alle lenernummers uit een lijst met leners.
De functie spreekt kwa code eigenlijk voor zich.
<pre>

> lenerNummers :: [Lener] -> [Int]
> lenerNummers [] = []
> lenerNummers (Lener lnr _ _ _ _ _ _ _ : xs) = lnr : lenerNummers xs

</pre>
De functie boekNummers doet exact hetzelfde maar dan voor boeken.
<pre>

> boekNummers :: [Boek] -> [Int]
> boekNummers [] = []
> boekNummers (Boek bnr _ _ _ _ : xs) = bnr : boekNummers xs

</pre>
De functie leningNummers doet exact hetzelfde maar dan voor leningen, maar aangezien
er geen leningnummers is, zet het de items in een string voor display in een pulldownmenu.
<pre>

> leningNummers :: [Lening] -> [String]
> leningNummers [] = []
> leningNummers (Lening bnr lnr _ : xs) = ((show bnr) ++ "--" ++ (show lnr)) : leningNummers xs

</pre>
De twee leningNummers geeft wel een tupel met boek- en lenersnummer terug.
<pre>

> leningNummers2 :: [Lening] -> [(Int, Int)]
> leningNummers2 [] = []
> leningNummers2 (Lening bnr lnr _ : xs) = (bnr, lnr) : leningNummers2 xs

</pre>
De functie indexToLenerNummers doet precies het omgekeerde: als je de index weet
van een nummer (lenernummer, boeknummer) in een bepaalde lijst items (boeken, leners),
dan haalt hij het nummer dat daarbij hoort voor je op.
<pre>

> indexToNummers :: Int -> [Int] -> Int
> indexToNummers i items = items !! i

</pre>
En indexToNummers2 doet dat voor tweetupels.
<pre>

> indexToNummers2 :: Int -> [(Int, Int)] -> (Int, Int)
> indexToNummers2 i items = items !! i

</pre>
De functie ongebruiktNummer retourneert de laagst mogelijke integer (>=0) die niet
voorkomt in een lijst integers. Hij gebruikt de hulpfunctie vindOngebruikt die bij 0
begint en kijkt of dat 0 vooraan in de lijst zit. Is het kleiner dan het eerste element
in de lijst dan is 0 ongebruikt, anders gaan we voor 1 kijken en een positie verder in
de lijst.
<pre>

> ongebruiktNummer :: [Int] -> Int
> ongebruiktNummer xss = vindOngebruikt 0 xss
>   where
>     vindOngebruikt i [] = i
>     vindOngebruikt i (x : xs) | i < x  = i
>                               | otherwise = vindOngebruikt (i+1) xs

</pre>
<b>Opslaan van bibliotheekgegevens</b><br/>
Eerst zorg ik dat het programma Leners, Boeken en Leningen kan opslaan.
De functie opslaanLeners schrijft een Lenersbestand
weg en kapselt het in in een begin en eind 'tag'. Het werkelijke parsen gebeurt
door de functie parseLeners, die een lijst van Leners converteert naar een string,
waar elke waarde en de begin en eind 'tag' op een aparte regel staan. Wel is het zo,
dat ik voor zowel Leners, Boeken en Leningen voor ieder steeds dezelfde
bestandsnaam neem. <br/>
Wel interessant is het om op te merken is dat ik een (zij het niet overal 100 procent valid) 
xml-formaat gebruik om mijn bestanden in op te slaan.
<pre>

> opslaanLeners :: Leners -> IO()
> opslaanLeners (Leners xs) = do let s = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n\n" ++
>                                     "<LENERS>\n" ++ parseLeners xs ++ "</LENERS>"
>                                writeFile "leners.xml" s
>                                return ()

> parseLeners :: [Lener] -> String
> parseLeners [] = ""
> parseLeners (Lener lnr voorn tussenv achtern str huisnr postc woonpl : xs)
>   = "<LENER>\n" ++ show lnr ++ "\n" ++ voorn ++ "\n" ++ tussenv ++ "\n" ++
>     achtern ++ "\n" ++ str ++ "\n" ++ huisnr ++ "\n" ++ postc ++ "\n" ++ woonpl
>     ++ "\n</LENER>\n" ++ parseLeners xs

</pre>
Op dezelfde manier sla ik in de hieronderstaande functies ook de Boeken en Leningen op.
Bij parseLeningen zit nog een addertje onder het gras, hier moet namelijk ook de datum
nog even worden geparsed. Dit gaat echter op dezelfde manier als de rest.
<pre>

> opslaanBoeken :: Boeken -> IO ()
> opslaanBoeken (Boeken xs) = do let s = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n\n" ++
>                                     "<BOEKEN>\n" ++ parseBoeken xs ++ "</BOEKEN>"
>                                writeFile "boeken.xml" s

> parseBoeken :: [Boek] -> String
> parseBoeken [] = ""
> parseBoeken (Boek bnr titel aut genre isbn : xs)
>   = "<BOEK>\n" ++ show bnr ++ "\n" ++ titel ++ "\n" ++ aut ++ "\n" ++
>     genre ++ "\n" ++ isbn ++ "\n</BOEK>\n" ++ parseBoeken xs

> opslaanLeningen :: Leningen -> IO ()
> opslaanLeningen (Leningen xs) = do let s = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n\n" ++
>                                         "<LENINGEN>\n" ++ parseLeningen xs ++ "</LENINGEN>"
>                                    writeFile "leningen.xml" s
>                                    return ()

> parseLeningen :: [Lening] -> String
> parseLeningen [] = ""
> parseLeningen (Lening bnr lnr datum : xs)
>   = "<LENING>\n" ++ show bnr ++ "\n" ++ show lnr ++ "\n" ++ parseDatum datum
>     ++ "\n</LENING>\n" ++ parseLeningen xs

> parseDatum :: Datum -> String
> parseDatum (Datum dag maand jaar) 
>   = "<DATUM>\n" ++ show dag ++ "\n" ++ show maand ++ "\n" ++ show jaar ++ "\n</DATUM>"

</pre>
<b>Lezen van bestanden</b><br/>
Nu lees ik van bestand. Hier definieer ik eerst een paar hulpfuncties. 
De hulpfunctie univParse neemt een lijst van String (dit zal het resultaat zijn
van de lines-functie waarbij elk element in de lijst overeenkomt met een regel 
in het bestand) en groepeert de lijst in een lijst van bij elkaar horende lijsten,
ofwel het pakt alle elementen van de lijst die tussen een begin en eind-element zitten
samen in een nieuwe lijst.
<pre>

> univParse :: Eq a => a -> a -> [a] -> [[a]]
> univParse start eind [] = []
> univParse start eind (x : xs) 
>   | start == x = takeWhile (/= eind) xs : univParse start eind (dropWhile (/= eind) xs)
>   | otherwise = univParse start eind xs

</pre>
De hulpfunctie stringValue krijgt een string en geeft de daarbijhorende integer-
waarde terug. Bijvoorbeeld "123" wordt 123. Dit doet hij door van links naar rechts
de lijst Char's door te lopen en steeds 10 maal de vorige waarden te doen en daarbij
de integer-waarde van het character op te tellen. Die wordt bepaald met behulp van
de standaardfunctie ord die characters naar hun ISO-codering mapt.
<pre>

> stringValue :: String -> Int
> stringValue str = foldl foo 0 str
>   where
>     foo e x = (10*e) + (digitValue x)
>     digitValue :: Char -> Int
>     digitValue c = ord c - ord '0'

</pre>
Nu ga ik de functies om Leners, Boeken en Leningen in te lezen schrijven. Om deze actie
te doen, heb ik per type twee functies nodig. De eerste functie leest het bestand in
en geeft die aan de functie reparseLeners, die er hopelijk een lijst van Lener van maakt.
Maar reparseLeners krijgt een lijst van strings mee mbv de functie lines, ofwel een lijst
van regels. Is het reparseLeners gelukt om een gevulde lijst Lener op te leveren, dan
wordt dat doorgegeven, anders retourneert leesLeners Nothing.
<pre>

> leesLeners :: IO (Maybe Leners)
> leesLeners = do s <- readFile "leners.xml"
>                 let b = reparseLeners (lines s)
>                 if b == []
>                    then return (Nothing)
>                    else return (Just (Leners b))

</pre>
De functie reparseLeners vervolgens hergroupeert middels de univParse-functie de
lijst met regels in een lijst van bij elkaar horende regels. Per lijst van bij elkaar
horende regels maakt hij er dan een Maybe Lener van, zodat de foldr van reparse er mbv
een foldr en gelukt alleen de waarden van Lener uithaalt die gelukt zijn, ofwel alleen
bij een Just lener de lener in de lijst zetten, en anders gewoon verder gaat.
<pre>

> reparseLeners :: [String] -> [Lener]
> reparseLeners [] = []
> reparseLeners xs = reparse (univParse "<LENER>" "</LENER>" xs)
>   where
>     reparse xss = foldr gelukt [] (map maakLener xss)
>     maakLener :: [String] -> Maybe Lener
>     maakLener (lnr : voorn : tussenv : achtern : str : huisnr : postc : woonpl : [])
>       =  Just (Lener (stringValue lnr) voorn tussenv achtern str huisnr postc woonpl)
>     maakLener xss = Nothing
>     gelukt Nothing  = ([] ++)
>     gelukt (Just x) = (x :)

</pre>
Hetzelfde kunstje herhaal ik nu, maar dan voor de boeken.
<pre>

> leesBoeken :: IO (Maybe Boeken)
> leesBoeken = do s <- readFile "boeken.xml"
>                 let b = reparseBoeken (lines s)
>                 if b == []
>                    then return (Nothing)
>                    else return (Just (Boeken b))

> reparseBoeken :: [String] -> [Boek]
> reparseBoeken [] = []
> reparseBoeken xs = reparse (univParse "<BOEK>" "</BOEK>" xs)
>   where
>     reparse xss = foldr gelukt [] (map maakBoek xss)
>     maakBoek :: [String] -> Maybe Boek
>     maakBoek (bnr : titel : auteur : genre : isbn : [])
>       =  Just (Boek (stringValue bnr) titel auteur genre isbn)
>     maakBoek xss = Nothing
>     gelukt Nothing  = ([] ++)
>     gelukt (Just x) = (x :)

</pre>
En nogmaals voor de leningen...
<pre>

> leesLeningen :: IO (Maybe Leningen)
> leesLeningen = do s <- readFile "leningen.xml"
>                   let l = reparseLeningen (lines s)
>                   if l == []
>                      then return (Nothing)
>                      else return (Just (Leningen l))

> reparseLeningen :: [String] -> [Lening]
> reparseLeningen [] = []
> reparseLeningen xs = reparse (univParse "<LENING>" "</LENING>" xs)
>   where
>     reparse xss = foldr gelukt [] (map maakLening xss)
>     maakLening :: [String] -> Maybe Lening
>     maakLening (lnr : bnr : _ : dag : maand : jaar : _ : [])
>       =  Just (Lening (stringValue lnr) (stringValue bnr) (Datum (stringValue dag) (stringValue maand) (stringValue jaar)))
>     maakLening xss = Nothing
>     gelukt Nothing  = ([] ++)
>     gelukt (Just x) = (x :)

</pre>

</body>
</html>