<html>

<head>
      <title>Readme bij bibliotheekopdracht (GUI)</title>
      <style type='text/css'>
      pre    { color: navy;
               display: inline-block;
               margin-top: 0em;
               margin-bottom: 0em;
             }
      </style>
</head>

<body>
<p>
naam          : Pieter van Ede <br/>
login         : pjede          <br/>
studentnummer : 3019764
</p>

Algemene opmerking: ik ga ervan uit, dat als de bestanden van de bibliotheek niet
te lezen zijn, dat deze dan nooit gemaakt zijn omdat de database dan pas net in 
gebruik is. Er word dan gewoon gedaan alsof het betreffende bestand geen items 
(leners, boeken, leningen) bevatte. <p/>

<b>Imports</b><br/>
Hier importeer ik de wxHaskell en IO mogelijkheden, evenals de zelfgeschreven
BiblioDB module, waarin de updatefuncties voor deze bibliotheekomgeving staan.
<pre>

> import BiblioDB
> import Directory
> import Graphics.UI.WX

</pre>
<b>De GUI</b><br/>
De functie main is er om het hele programma te kunnen aanzwengelen, en aangezien die
meteen de functie start gui aanroept, betekent dat dat er een wxHaskell GUI volgens 
het recept in de functie gui wordt geladen.
<pre>

> main = start gui

</pre>
De functie gui maakt een menubar (met behulp van de functie maakFileMenu) en een 
panel met daarin een notebook (=tabbladen) layout aan. Vervolgens maakt het een 
voor een de panels aan die in de tabbladen moeten komen met behulp van speciale
functies per tabblad, en zet vervolgens menubar, statusbalk en tabbladen layout vast.
<pre>

> gui :: IO ()
> gui = do
>   f               <- frame [text := "Bibliotheek uitleen-service"]
>   filemenu        <- maakFileMenu f
>   status          <- statusField [text := "Bibliotheek uitleen"]
>   content         <- panel f []
>   nb              <- notebook f []
>   lenersbestand   <- leesLeners
>   leners          <- variable [value := lenersbestand]
>   boekenbestand   <- leesBoeken
>   boeken          <- variable [value := boekenbestand]
>   leningenbestand <- leesLeningen
>   leningen        <- variable [value := leningenbestand]

>   (toonLenerPanel, lenerView)                  <- toonLeners f leners
>   insertLenerPanel                             <- maakLenerInvoer f leners
>   (updateLenerPanel, updateLeners)             <- maakLenerUpdater f leners
>   (verwijderLenerPanel, deleteLeners)          <- maakLenerVerwijderaar f leners
>   (toonBoekPanel, boekView)                    <- toonBoeken f boeken
>   insertBoekPanel                              <- maakBoekInvoer f boeken
>   (updateBoekPanel, updateBoeken)              <- maakBoekUpdater f boeken
>   (verwijderBoekPanel, deleteBoeken)           <- maakBoekVerwijderaar f boeken
>   (insertLeningPanel, lenerKiezer, boekKiezer) <- maakLeningInvoer f leningen
>   (updateLeningPanel, updateLeningen)          <- maakLeningUpdater f leningen
>   (verwijderLeningPanel, deleteLeningen)       <- maakLeningVerwijderaar f leningen

>   set f [menuBar := [filemenu], statusbar := [status], on closing := closer f leners boeken leningen,
>       on paint := updateGUI leners boeken leningen updateLeners deleteLeners updateBoeken deleteBoeken
>       lenerView boekView lenerKiezer boekKiezer updateLeningen deleteLeningen]
>   set f [layout := tabs nb [ tab "Bekijk leners"         (container toonLenerPanel $ glue ),
>                              tab "Voeg leners toe"       (container insertLenerPanel $ glue ),
>                              tab "Update lenersgegevens" (container updateLenerPanel $ glue ),
>                              tab "Verwijder leners"      (container verwijderLenerPanel $ glue ),
>                              tab "Bekijk boeken"         (container toonBoekPanel $ glue ),
>                              tab "Voeg boeken toe"       (container insertBoekPanel $ glue ),
>                              tab "Update boekengegevens" (container updateBoekPanel $ glue ),
>                              tab "Verwijder boeken"      (container verwijderBoekPanel $ glue),
>                              tab "Voeg leningen toe"     (container insertLeningPanel $ glue ),
>                              tab "Update leninggegevens" (container updateLeningPanel $ glue ),
>                              tab "Verwijder lening"      (container verwijderLeningPanel $ glue) ]]
>   return ()

</pre>
De functie maakFileMenu maakt (surprise surprise) het menu-item file aan, met de
standaard wxHaskell functies daarvoor.
<pre>

> maakFileMenu :: Frame () -> IO (Menu ())
> maakFileMenu f =  do
>   mfile <- menuPane [text := "&File"]
>   quit  <- menuQuit mfile [help := "Quit program.", on command := close f]
>   return mfile

</pre>
De functie updateGUI zorgt ervoor dat alle elementen in de GUI, die afhankelijk
zijn van 'mutable variabelen' zoals bijvoorbeeld leners en boeken, dat die opnieuw
getekend kunnen worden als die worden gewijzigd. Om een voorbeeld te noemen: als een
lener verwijderd wordt, moet hij ook uit de keuzelijst van de te updaten en verwijderen
lenes verdwijnen.
<pre>

> updateGUI :: Var (Maybe Leners) -> Var (Maybe Boeken) -> Var (Maybe Leningen) -> Choice a -> Choice a ->
>    Choice b -> Choice b -> StaticText c -> StaticText c -> Choice a -> Choice b -> Choice c -> Choice c -> DC () -> Rect -> IO ()
> updateGUI lenersvar boekenvar leningenvar lenerkiezer1 lenerkiezer2 boekkiezer1 
>  boekkiezer2 lenerView boekView boekkiezer3 lenerkiezer3 leningkiezer1 leningkiezer2 dc view = do
>   -- de lijst met lenernummers in de verschillende pull-down menus worden geupdate
>   leners <- get lenersvar value
>   case leners of
>     Nothing -> do
>       set lenerkiezer1 [items := [x | x <- ["niks"] ::[String] ]]
>       set lenerkiezer2 [items := [x | x <- ["niks"] ::[String] ]]
>       set lenerkiezer3 [items := [x | x <- ["niks"] ::[String] ]]
>     Just (Leners xs) -> do
>       let lenersitems = [show x | x <- (lenerNummers xs)]
>       set lenerkiezer1 [items := [x | x <- lenersitems] ]
>       set lenerkiezer2 [items := [x | x <- lenersitems] ]
>       set lenerkiezer3 [items := [x | x <- lenersitems] ]
>   -- de lijst met boeknummers in de verschillende pull-down menus worden geupdate
>   boeken <- get boekenvar value
>   case boeken of
>     Nothing -> do
>       set boekkiezer1 [items := [x | x <- ["niks"] ::[String] ]]
>       set boekkiezer2 [items := [x | x <- ["niks"] ::[String] ]]
>       set boekkiezer3 [items := [x | x <- ["niks"] ::[String] ]]
>     Just (Boeken xs) -> do
>       let boekitems = [show x | x <- (boekNummers xs)]
>       set boekkiezer1 [items := [x | x <- boekitems] ]
>       set boekkiezer2 [items := [x | x <- boekitems] ]
>       set boekkiezer3 [items := [x | x <- boekitems] ]
>   -- de lijst met leningen in de verschillende pull-down menus worden geupdate
>   leningen <- get leningenvar value
>   case leningen of
>     Nothing -> do
>       set leningkiezer1 [items := [x | x <- ["niks"] ::[String] ]]
>       set leningkiezer2 [items := [x | x <- ["niks"] ::[String] ]]
>     Just (Leningen xs) -> do
>       let leningitems = [show x | x <- (leningNummers xs)]
>       set leningkiezer1 [items := [x | x <- leningitems] ]
>       set leningkiezer2 [items := [x | x <- leningitems] ]
>   -- het venster waarin alle leners worden weergegeven wordt aangepast
>   mleners <- get lenersvar value
>   case mleners of
>     Nothing          -> do set lenerView [text := "Geen leners in het systeem"]
>     Just (Leners xs) -> do let lenersString = toStringL xs
>                            set lenerView [text := lenersString]
>   -- het venster waarin alle boeken worden weergegeven wordt aangepast
>   mboeken <- get boekenvar value
>   case mboeken of
>     Nothing          -> do set boekView [text := "Geen boeken in het systeem"]
>     Just (Boeken xs) -> do let boekenString = toStringB xs
>                            set boekView [text := boekenString]
>     where
>         toStringL [] = []
>         toStringL (Lener lnr voorn tussenv achtern str huisnr postc woonpl : xs)
>           = show lnr ++ "\n" ++ voorn ++ "\n" ++ tussenv ++ "\n" ++ achtern
>           ++ "\n" ++ str ++ "\n" ++ huisnr ++ "\n" ++ postc ++ "\n" ++ woonpl
>           ++ "\n--------------------------------------------------------------------------------\n"
>           ++ toStringL xs
>         toStringB [] = []
>         toStringB (Boek bnr titel auteur genre isbn : xs)
>           = show bnr ++ "\n" ++ titel ++ "\n" ++ auteur ++ "\n" ++ genre
>           ++ "\n" ++ isbn
>           ++ "\n--------------------------------------------------------------------------------\n"
>           ++ toStringB xs

</pre>
De functie closer zorgt ervoor dat als het programma wordt afgesloten, dat
dan de gemaakte wijzigingen in het leners-, boeken- en leningenbestand ook
worden opgeslagen. Vervolgens wordt met behulp van het statement propagateEvent
bewerkstelligt dat het event, in dit geval het closing event, verder wordt
verwerkt. Zou ik hier namelijk weer 'close f' opschrijven, is dat identiek aan
mezelf recursief aanroepen en daarmee een oneindige loop veroorzaken. Door het 
event door te geven, wordt het verder verwerkt op de standaard manier, en dat
is het venster weghalen en het programma beindigen.
<pre>

> closer :: Frame () -> Var (Maybe Leners) -> Var (Maybe Boeken) -> Var (Maybe Leningen) -> IO ()
> closer f lenersvar boekenvar leningenvar = do
>   mlener <- get lenersvar value
>   case mlener of
>     Nothing -> do return ()
>     Just leners -> do
>       opslaanLeners leners
>   mboek <- get boekenvar value
>   case mboek of
>     Nothing -> do return ()
>     Just boeken -> do
>       opslaanBoeken boeken
>   mlening <- get leningenvar value
>   case mlening of
>     Nothing -> do return ()
>     Just leningen -> do
>       opslaanLeningen leningen
>   propagateEvent

</pre>
<b>De tabbladen voor het bewerken van de lenergegevens</b><br/>
Deze functie maakt het panel dat onder het 'lenerinvoer-tabblad' komt te staan.
Het zet de widgets vast op de goede plaats en retourneert het overkoepelende
panel dan. Zodra er op de knop wordt gedrukt, activeert het de invoerLenerHandler
de gegevens ook daadwerkelijk zal toevoegen.
<pre>

> maakLenerInvoer :: Frame () -> Var (Maybe (Leners)) -> IO (Panel ())
> maakLenerInvoer f lenersvar = do
>   invoerLenerPanel    <- panel f []
>   beschrVoornaam      <- staticText invoerLenerPanel [text := "Voornaam"]
>   invoerVoornaam      <- entry invoerLenerPanel []
>   beschrTussenvoegsel <- staticText invoerLenerPanel [text := "Tussenvoegsel"]
>   invoerTussenvoegsel <- entry invoerLenerPanel []
>   beschrAchternaam    <- staticText invoerLenerPanel [text := "Achternaam"]
>   invoerAchternaam    <- entry invoerLenerPanel []
>   beschrStraat        <- staticText invoerLenerPanel [text := "Straat"]
>   invoerStraat        <- entry invoerLenerPanel []
>   beschrHuisnummer    <- staticText invoerLenerPanel [text := "Huisnummer"]
>   invoerHuisnummer    <- entry invoerLenerPanel []
>   beschrPostcode      <- staticText invoerLenerPanel [text := "Postcode"]
>   invoerPostcode      <- entry invoerLenerPanel []
>   beschrWoonplaats    <- staticText invoerLenerPanel [text := "Woonplaats"]
>   invoerWoonplaats    <- entry invoerLenerPanel []
>   process             <- button invoerLenerPanel [text := "Verwerk lenerinformatie", 
>      on command := invoerLenerHandler f invoerVoornaam invoerTussenvoegsel invoerAchternaam
>      invoerStraat invoerHuisnummer invoerPostcode invoerWoonplaats lenersvar]
>   set invoerLenerPanel [layout := boxed "Lenergegevens" $ column 5 [widget beschrVoornaam, widget invoerVoornaam,
>     widget beschrTussenvoegsel, widget invoerTussenvoegsel, widget beschrAchternaam,
>     widget invoerAchternaam, widget beschrStraat, widget invoerStraat, widget beschrHuisnummer,
>     widget invoerHuisnummer, widget beschrPostcode, widget invoerPostcode, widget beschrWoonplaats,
>     widget invoerWoonplaats, widget process] ]
>   return (invoerLenerPanel)

</pre>
Deze functie lijkt vrij hetzelfde als de vorige functie, alleen laat het de gebruiker
eerst een lenernummer kiezen, om vervolgens met behulp van de selectiehandler van
het pulldown menu de gegevens van de betreffende gebruiker te kunnen laden in
een aapasformulier, zodat ze kunnen worden aangepast. Het haalt deze lijst met gebruikers
uit een Var, en aangezien die Var Nothing kan bevatten, moet daar eerst even op
getest worden. Heel bewust hergebruik ik niet bovenstaande functie, want naast dat dat 
een hoop errors gaf, geeft dit ook moeilijkheden met het kunnen meegeven van de entrys 
waarin nieuwe waarden moeten worden klaargezet.  <br/>
Daarnaast moet het lenernummer in een variabele worden opgeslagen aangezien die niet in
tekstveld mag staan, want die mag niet veranderd worden.
<pre>

> maakLenerUpdater :: Frame () -> Var (Maybe (Leners)) -> IO (Panel (), Choice ())
> maakLenerUpdater f lenersvar = do
>   updateLenerPanel <- panel f []
>   beschrKiezer     <- staticText updateLenerPanel [text := "Kies de te updaten lener"]
>   kiezer           <- choice updateLenerPanel []
>   let lnr = -1
>   lennr            <- variable [value := lnr]
>
>   invoerLenerPanel    <- panel updateLenerPanel []
>   beschrVoornaam      <- staticText invoerLenerPanel [text := "Voornaam"]
>   updateVoornaam      <- entry invoerLenerPanel []
>   beschrTussenvoegsel <- staticText invoerLenerPanel [text := "Tussenvoegsel"]
>   updateTussenvoegsel <- entry invoerLenerPanel []
>   beschrAchternaam    <- staticText invoerLenerPanel [text := "Achternaam"]
>   updateAchternaam    <- entry invoerLenerPanel []
>   beschrStraat        <- staticText invoerLenerPanel [text := "Straat"]
>   updateStraat        <- entry invoerLenerPanel []
>   beschrHuisnummer    <- staticText invoerLenerPanel [text := "Huisnummer"]
>   updateHuisnummer    <- entry invoerLenerPanel []
>   beschrPostcode      <- staticText invoerLenerPanel [text := "Postcode"]
>   updatePostcode      <- entry invoerLenerPanel []
>   beschrWoonplaats    <- staticText invoerLenerPanel [text := "Woonplaats"]
>   updateWoonplaats    <- entry invoerLenerPanel []
>   process             <- button invoerLenerPanel [text := "Verwerk lenerinformatie",
>      on command := updateLenerHandler f lennr updateVoornaam updateTussenvoegsel updateAchternaam
>      updateStraat updateHuisnummer updatePostcode updateWoonplaats lenersvar]
>
>   set invoerLenerPanel [visible := False, layout := boxed "Lenergegevens" $ column 5 [widget beschrVoornaam, widget updateVoornaam,
>     widget beschrTussenvoegsel, widget updateTussenvoegsel, widget beschrAchternaam,
>     widget updateAchternaam, widget beschrStraat, widget updateStraat, widget beschrHuisnummer,
>     widget updateHuisnummer, widget beschrPostcode, widget updatePostcode, widget beschrWoonplaats,
>     widget updateWoonplaats, widget process]]
>   set kiezer [on select := updateLenerKiezerHandler kiezer invoerLenerPanel lenersvar lennr updateVoornaam
>       updateTussenvoegsel updateAchternaam updateStraat updateHuisnummer updatePostcode updateWoonplaats]
>   set updateLenerPanel [layout := row 5 [boxed "Lener" $ column 5 [widget beschrKiezer, widget kiezer ],
>     column 5 [widget invoerLenerPanel] ] ]
>   return (updateLenerPanel, kiezer)

</pre>
Deze functie zorgt voor de mogelijkheid om leners te kunnen verwijderen.
Het haalt de leners op uit de variabele, kijkt of de waarde erin niet Nothing
is, en zet de lijst en overige widgets klaar. Tevens koppelt hij de eventhandler
deleteLenerHandler aan de keuzelijst om ook daadwerkelijk te kunnen gaan deleten.
<pre>

> maakLenerVerwijderaar :: Frame () -> Var (Maybe Leners) -> IO (Panel (), Choice ())
> maakLenerVerwijderaar f lenersvar = do
>   leners           <- get lenersvar value
>   deleteLenerPanel <- panel f []
>   beschrKiezer     <- staticText deleteLenerPanel [text := "Kies de te verwijderen lener"]
>   kiezer           <- choice deleteLenerPanel []
>   set kiezer [on select := verwijderLenerHandler kiezer f lenersvar]
>   set deleteLenerPanel [layout := boxed "Verwijder lener" $ column 5 [widget beschrKiezer, widget kiezer] ]
>   return (deleteLenerPanel, kiezer)

</pre>
<b>Handlers behorende bij de lener-tabbladen</b><br/>
De addLenerHandler zorgt ervoor dat als er gegevens voor een lener worden ingevoerd,
dat de lener dan ook daadwerkelijk wordt toevoegd.
<pre>

> invoerLenerHandler :: Frame b -> TextCtrl a -> TextCtrl a -> TextCtrl a -> TextCtrl a ->
>     TextCtrl a -> TextCtrl a -> TextCtrl a -> Var (Maybe Leners) -> IO ()
> invoerLenerHandler f voornv tussenvv achternv straatv huisnrv postcodev woonplv lenervar = do
>   voorn    <- get voornv text
>   tussenv  <- get tussenvv text
>   achtern  <- get achternv text
>   straat   <- get straatv text
>   huisnr   <- get huisnrv text
>   postcode <- get postcodev text
>   woonpl   <- get woonplv text
>   leners   <- get lenervar value
>   case leners of
>     Nothing  -> do
>       let l = maakLener (Leners []) 0 voorn tussenv achtern straat huisnr postcode woonpl
>       set lenervar [value := Just (l)]
>     Just leners@(Leners xs) -> do
>       let lnr = ongebruiktNummer  (lenerNummers xs)
>       let l = maakLener leners lnr voorn tussenv achtern straat huisnr postcode woonpl
>       set lenervar [value := Just (l)]
>   infoDialog f "Info" "Lener is succesvol toegevoegd."
>   repaint f
>   return ()

</pre>
De lenerKiezerHandler zorgt ervoor dat als er een item in de keuzelijst is
geselecteerd, dat dan de daarmee corresponderende lener in het formulier
wordt geladen en dat dat formulier zichtbaar wordt. Gaat er iets fout, dan
wordt de gebruiker daarvan op de hoogte gebracht.
<pre>

> updateLenerKiezerHandler :: Choice () -> Panel c -> Var (Maybe Leners) -> Var (Lenersnummer) ->
>   TextCtrl b -> TextCtrl b -> TextCtrl b -> TextCtrl b -> TextCtrl b -> TextCtrl b -> TextCtrl b -> IO ()
> updateLenerKiezerHandler kiezer p leners lennr vo tus acht st nr pos pla = do
>   selectie <- get kiezer selection
>   len      <- get leners value
>   case len of
>     Nothing    -> do errorDialog p "Probleem" "Er zijn geen leners om te veranderen."
>     Just lener@(Leners xs) -> do
>       let mlener = zoekLener lener (indexToNummers selectie (lenerNummers xs))
>       case mlener of
>         Nothing    -> do errorDialog p "Probleem" "Er zijn geen leners om te veranderen."
>         Just (Lener lnr voorn tussenv achtern str huisnr postc woonpl) -> do
>           set p [visible := True]
>           set lennr [value := lnr]
>           set vo   [text := voorn]
>           set tus  [text := tussenv]
>           set acht [text := achtern]
>           set st   [text := str]
>           set nr   [text := huisnr]
>           set pos  [text := postc]
>           set pla  [text := woonpl]

</pre>
De functie updateLenerHandler zorgt ervoor dat, zodra de gegevens in het formulier
van een bepaalde persoon zijn gewijzigd, deze wijzigingen ook in de leners variabele
worden opgeslagen. Dit doet de functie door de waarden van de velden op te halen en
het lenernummer van de lener die bewerkt wordt uit de variabele halen. Ook deze handler
geeft een foutmelding als iets fout gaat.
<pre>

> updateLenerHandler :: Frame b -> Var (Lenersnummer) -> TextCtrl a -> TextCtrl a -> TextCtrl a -> TextCtrl a ->
>     TextCtrl a -> TextCtrl a -> TextCtrl a -> Var (Maybe Leners) -> IO ()
> updateLenerHandler f lnrv voornv tussenvv achternv straatv huisnrv postcodev woonplv lenervar = do
>   lnr      <- get lnrv value
>   voorn    <- get voornv text
>   tussenv  <- get tussenvv text
>   achtern  <- get achternv text
>   straat   <- get straatv text
>   huisnr   <- get huisnrv text
>   postcode <- get postcodev text
>   woonpl   <- get woonplv text
>   leners   <- get lenervar value
>   case leners of
>     Nothing    -> do errorDialog f "Probleem" "Er zijn geen leners om te veranderen."
>     Just leners@(Leners xs) -> do
>       let l = wijzigLener leners lnr voorn tussenv achtern straat huisnr postcode woonpl
>       set lenervar [value := Just (l)]
>       infoDialog f "Info" "Lener is succesvol gewijzigd."
>   repaint f
>   return ()

</pre>
De deleteLenerHandler zorgt ervoor dat als er een lener in de keuzelijst
is geselecteerd, dat dan de lener wordt verwijder en een bevestiging 
daarvan wordt verstuurd.
<pre>

> verwijderLenerHandler :: Choice () -> Frame a -> Var (Maybe Leners) -> IO ()
> verwijderLenerHandler kiezer f lenervar = do
>   selectie <- get kiezer selection
>   len      <- get lenervar value
>   case len of
>     Nothing    -> do errorDialog f "Probleem" "Er zijn geen leners om te verwijderen."
>     Just leners@(Leners xs) -> do
>       let mlener = zoekLener leners (indexToNummers selectie (lenerNummers xs))
>       case mlener of
>         Nothing    -> do errorDialog f "Probleem" "Er zijn geen leners om te verwijderen."
>         Just (Lener lnr _ _ _ _ _ _ _) -> do
>           let l = verwijderLener leners lnr
>           set lenervar [value := Just (l)]
>           infoDialog f "Info" "Lener is succesvol verwijderd."
>           repaint f

</pre>
<b>Tabbladen voor het bewerken van de boeken</b><br/>
Deze functie maakt een panel aan op exact dezelfde wijze, als dat dat gebeurde bij
de lenerinvoer. Zie daar voor verdere uitleg over het principe.
<pre>

> maakBoekInvoer :: Frame () -> Var (Maybe (Boeken)) -> IO (Panel ())
> maakBoekInvoer f boekenvar = do
>   invoerBoekPanel <- panel f []
>   beschrTitel     <- staticText invoerBoekPanel [text := "Titel"]
>   invoerTitel     <- entry invoerBoekPanel []
>   beschrAuteur    <- staticText invoerBoekPanel [text := "Auteur"]
>   invoerAuteur    <- entry invoerBoekPanel []
>   beschrGenre     <- staticText invoerBoekPanel [text := "Genre"]
>   invoerGenre     <- entry invoerBoekPanel []
>   beschrISBN      <- staticText invoerBoekPanel [text := "ISBN"]
>   invoerISBN      <- entry invoerBoekPanel []
>   process         <- button invoerBoekPanel [text := "Verwerk boekinformatie",
>      on command := invoerBoekHandler f invoerTitel invoerAuteur invoerGenre
>      invoerISBN boekenvar]
>   set invoerBoekPanel [layout := boxed "Boekgegevens" $ column 5 [widget beschrTitel, widget invoerTitel,
>     widget beschrAuteur, widget invoerAuteur, widget beschrGenre,
>     widget invoerGenre, widget beschrISBN, widget invoerISBN, widget process] ]
>   return (invoerBoekPanel)

</pre>
De functie maakBoekUpdater werkt ook analoog aan de functie maakLenerUpdater.
<pre>

> maakBoekUpdater :: Frame () -> Var (Maybe (Boeken)) -> IO (Panel (), Choice ())
> maakBoekUpdater f boekenvar = do
>   updateBoekPanel <- panel f []
>   beschrKiezer     <- staticText updateBoekPanel [text := "Kies het te updaten boek"]
>   kiezer           <- choice updateBoekPanel []
>   let bnr = -1
>   boeknr            <- variable [value := bnr]
>
>   invoerBoekPanel <- panel updateBoekPanel []
>   beschrTitel     <- staticText invoerBoekPanel [text := "Titel"]
>   updateTitel     <- entry invoerBoekPanel []
>   beschrAuteur    <- staticText invoerBoekPanel [text := "Auteur"]
>   updateAuteur    <- entry invoerBoekPanel []
>   beschrGenre     <- staticText invoerBoekPanel [text := "Genre"]
>   updateGenre     <- entry invoerBoekPanel []
>   beschrISBN      <- staticText invoerBoekPanel [text := "ISBN"]
>   updateISBN      <- entry invoerBoekPanel []
>   process         <- button invoerBoekPanel [text := "Verwerk boekinformatie",
>      on command := updateBoekHandler f boeknr updateTitel updateAuteur updateGenre
>      updateISBN boekenvar]
>
>   set invoerBoekPanel [visible := False, layout := boxed "Boekgegevens" $ column 5 [widget beschrTitel, widget updateTitel,
>     widget beschrAuteur, widget updateAuteur, widget beschrGenre,
>     widget updateGenre, widget beschrISBN, widget updateISBN, widget process]]
>   set kiezer [on select := updateBoekKiezerHandler kiezer invoerBoekPanel boekenvar
>     boeknr updateTitel updateAuteur updateGenre updateISBN]
>   set updateBoekPanel [layout := row 5 [boxed "Boek" $ column 5 [widget beschrKiezer, widget kiezer ],
>     column 5 [widget invoerBoekPanel] ] ]
>   return (updateBoekPanel, kiezer)

</pre>
En ook de functie maakBoekVerwijderaar werkt analoog aan de functie maakLenerVerwijderaar.
<pre>

> maakBoekVerwijderaar :: Frame () -> Var (Maybe Boeken) -> IO (Panel (), Choice ())
> maakBoekVerwijderaar f boekenvar = do
>   boeken           <- get boekenvar value
>   deleteBoekPanel <- panel f []
>   beschrKiezer     <- staticText deleteBoekPanel [text := "Kies het te verwijderen boek"]
>   kiezer           <- choice deleteBoekPanel []
>   set kiezer [on select := verwijderBoekHandler kiezer f boekenvar]
>   set deleteBoekPanel [layout := boxed "Verwijder lener" $ column 5 [widget beschrKiezer, widget kiezer] ]
>   return (deleteBoekPanel, kiezer)

</pre>
<b>Handlers behorende bij de tabbladen voor het bewerken van de boeken</b><br/>
Deze handlers werken echt exact hetzelfde als de handlers van de lenersgegevens, 
daarom voeg ik geen extra commentaar per functie toe, maar verwijs ik naar de 
analoge functie voor leners.
<pre>

> invoerBoekHandler :: Frame b -> TextCtrl a -> TextCtrl a -> TextCtrl a -> TextCtrl a ->
>     Var (Maybe Boeken) -> IO ()
> invoerBoekHandler f titelv auteurv genrev isbnv boekenvar = do
>   titel  <- get titelv text
>   auteur <- get auteurv text
>   genre  <- get genrev text
>   isbn   <- get isbnv text
>   boeken <- get boekenvar value
>   case boeken of
>     Nothing  -> do
>       let b = maakBoek (Boeken []) 0 titel auteur genre isbn
>       set boekenvar [value := Just (b)]
>     Just boeken@(Boeken xs) -> do
>       let bnr = ongebruiktNummer  (boekNummers xs)
>       let b = maakBoek boeken bnr titel auteur genre isbn
>       set boekenvar [value := Just (b)]
>   infoDialog f "Info" "Boek is succesvol toegevoegd."
>   repaint f
>   return ()

> updateBoekKiezerHandler :: Choice () -> Panel c -> Var (Maybe Boeken) -> Var (Boeknummer) ->
>   TextCtrl b -> TextCtrl b -> TextCtrl b -> TextCtrl b -> IO ()
> updateBoekKiezerHandler kiezer p boeken bonr tit aut gen isb = do
>   selectie <- get kiezer selection
>   bo       <- get boeken value
>   case bo of
>     Nothing    -> do errorDialog p "Probleem" "Er zijn geen boeken om te veranderen."
>     Just boek@(Boeken xs) -> do
>       let mboek = zoekBoek boek (indexToNummers selectie (boekNummers xs))
>       case mboek of
>         Nothing    -> do errorDialog p "Probleem" "Er zijn geen boeken om te veranderen."
>         Just (Boek bnr titel auteur genre isbn) -> do
>           set p [visible := True]
>           set bonr [value := bnr]
>           set tit  [text := titel]
>           set aut  [text := auteur]
>           set gen  [text := genre]
>           set isb  [text := isbn]

> updateBoekHandler :: Frame b -> Var (Boeknummer) -> TextCtrl a -> TextCtrl a -> TextCtrl a -> TextCtrl a ->
>     Var (Maybe Boeken) -> IO ()
> updateBoekHandler f bnrv titelv auteurv genrev isbnv boekenvar = do
>   bnr    <- get bnrv value
>   titel  <- get titelv text
>   auteur <- get auteurv text
>   genre  <- get genrev text
>   isbn   <- get isbnv text
>   boeks  <- get boekenvar value
>   case boeks of
>     Nothing    -> do errorDialog f "Probleem" "Er zijn geen boeken om te veranderen."
>     Just boeken@(Boeken xs) -> do
>       let b = wijzigBoek boeken bnr titel auteur genre isbn
>       set boekenvar [value := Just (b)]
>       infoDialog f "Info" "Boek is succesvol gewijzigd."
>   repaint f
>   return ()

> verwijderBoekHandler :: Choice () -> Frame a -> Var (Maybe Boeken) -> IO ()
> verwijderBoekHandler kiezer f boekenvar = do
>   selectie <- get kiezer selection
>   boe      <- get boekenvar value
>   case boe of
>     Nothing    -> do errorDialog f "Probleem" "Er zijn geen boeken om te verwijderen."
>     Just boeken@(Boeken xs) -> do
>       let mboek = zoekBoek boeken (indexToNummers selectie (boekNummers xs))
>       case mboek of
>         Nothing    -> do errorDialog f "Probleem" "Er zijn geen boeken om te verwijderen."
>         Just (Boek bnr _ _ _ _) -> do
>           let b = verwijderBoek boeken bnr
>           set boekenvar [value := Just (b)]
>           infoDialog f "Info" "Boeken is succesvol verwijderd."
>           repaint f

</pre>
Deze hele simpele functies zorgen ervoor dat alle leners en boeken kunnen worden afgelezen.
<pre>

> toonLeners :: Frame () -> Var (Maybe Leners) -> IO (Panel (), StaticText ())
> toonLeners f lenersvar = do
>   toonLenersPanel <- panel f []
>   lenersView      <- staticText toonLenersPanel []
>   set toonLenersPanel [layout := widget lenersView]
>   return (toonLenersPanel, lenersView)

> toonBoeken :: Frame () -> Var (Maybe Boeken) -> IO (Panel (), StaticText ())
> toonBoeken f boekenvar = do
>   toonBoekenPanel <- panel f []
>   boekenView      <- staticText toonBoekenPanel []
>   set toonBoekenPanel [layout := widget boekenView]
>   return (toonBoekenPanel, boekenView)

</pre>
<b>Tabbladen voor het bewerken van de leningen</b><br/>
Deze functie maakt een panel aan op exact dezelfde wijze, als dat dat gebeurde bij
de lenerinvoer. Zie daar voor verdere uitleg over het principe.
<pre>

> maakLeningInvoer :: Frame () -> Var (Maybe (Leningen)) -> IO (Panel (), Choice (), Choice ())
> maakLeningInvoer f leningenvar = do
>   invoerLeningPanel <- panel f []
>   beschrBoek      <- staticText invoerLeningPanel [text := "Boek"]
>   boekKiezer      <- choice invoerLeningPanel []
>   beschrLener     <- staticText invoerLeningPanel [text := "Lener"]
>   lenerKiezer     <- choice invoerLeningPanel []
>   beschrDatum     <- staticText invoerLeningPanel [text := "Inleverdatum"]
>   beschrDag       <- staticText invoerLeningPanel [text := "Dag"]
>   invoerDag       <- entry invoerLeningPanel []
>   beschrMaand     <- staticText invoerLeningPanel [text := "Maand"]
>   invoerMaand     <- entry invoerLeningPanel []
>   beschrJaar      <- staticText invoerLeningPanel [text := "Jaar"]
>   invoerJaar      <- entry invoerLeningPanel []
>   process         <- button invoerLeningPanel [text := "Verwerk lening",
>      on command := invoerLeningHandler f lenerKiezer boekKiezer invoerDag
>      invoerMaand invoerJaar leningenvar]
>   set invoerLeningPanel [layout := boxed "Leninggegevens" $ column 5 [widget beschrBoek,
>     widget boekKiezer, widget beschrLener, widget lenerKiezer, widget beschrDatum,
>     grid 5 5 [[widget beschrDag, widget beschrMaand, widget beschrJaar],
>     [widget invoerDag, widget invoerMaand, widget invoerJaar]], widget process] ]
>   return (invoerLeningPanel, boekKiezer, lenerKiezer)

</pre>
De functie maakLeningUpdater werkt ook analoog aan de functie maakLenerUpdater,
met het verschil dat de aangemaakte variabele nu geen lenersnummer opslaat, maar 
een tupel met lenersnummer en boeknummer, omdat die beide nodig zijn om een lening
te kunnen identificeren.
<pre>

> maakLeningUpdater :: Frame () -> Var (Maybe Leningen) -> IO (Panel (), Choice ())
> maakLeningUpdater f leningenvar = do
>   updateLeningPanel <- panel f []
>   beschrKiezer     <- staticText updateLeningPanel [text := "Kies het te updaten boek"]
>   kiezer           <- choice updateLeningPanel []
>   leninginfo       <- variable []
>
>   invoerLeningPanel <- panel updateLeningPanel []
>   beschrDatum       <- staticText invoerLeningPanel [text := "Nieuwe inleverdatum"]
>   beschrDag         <- staticText invoerLeningPanel [text := "Dag"]
>   invoerDag         <- entry invoerLeningPanel []
>   beschrMaand       <- staticText invoerLeningPanel [text := "Maand"]
>   invoerMaand       <- entry invoerLeningPanel []
>   beschrJaar        <- staticText invoerLeningPanel [text := "Jaar"]
>   invoerJaar        <- entry invoerLeningPanel []
>   process           <- button invoerLeningPanel [text := "Verwerk lening",
>      on command := updateLeningHandler f invoerDag
>      invoerMaand invoerJaar leningenvar leninginfo]
>
>   set invoerLeningPanel [visible := False, layout := boxed "Leninggegevens" $ column 5 [widget beschrDatum,
>     grid 5 5 [[widget beschrDag, widget beschrMaand, widget beschrJaar],
>     [widget invoerDag, widget invoerMaand, widget invoerJaar]], widget process] ]
>   set kiezer [on select := updateLeningKiezerHandler kiezer invoerLeningPanel leningenvar leninginfo]
>   set updateLeningPanel [layout := row 5 [boxed "Lening" $ column 5 [widget beschrKiezer, widget kiezer ],
>     column 5 [widget invoerLeningPanel] ] ]
>   return (updateLeningPanel, kiezer)

</pre>
En ook de functie maakLeningVerwijderaar werkt analoog aan de functie maakLenerVerwijderaar.
<pre>

> maakLeningVerwijderaar :: Frame () -> Var (Maybe Leningen) -> IO (Panel (), Choice ())
> maakLeningVerwijderaar f leningenvar = do
>   deleteLeningPanel <- panel f []
>   beschrKiezer      <- staticText deleteLeningPanel [text := "Kies de te verwijderen lening"]
>   kiezer            <- choice deleteLeningPanel []
>   set kiezer [on select := verwijderLeningHandler kiezer f leningenvar]
>   set deleteLeningPanel [layout := boxed "Verwijder lening" $ column 5 [widget beschrKiezer, widget kiezer] ]
>   return (deleteLeningPanel, kiezer)

</pre>
<b>Handlers behorende bij de tabbladen voor het bewerken van de leningen</b><br/>
Deze handlers werken vrij hetzelfde als de voorgaande handlers. <br/>
<pre>

> invoerLeningHandler :: Frame b -> Choice () -> Choice () -> TextCtrl a -> TextCtrl a ->
>     TextCtrl a -> Var (Maybe Leningen) -> IO ()
> invoerLeningHandler f boekkiezer lenerkiezer dagv maandv jaarv leningenvar = do
>   bnr      <- get boekkiezer selection
>   lnr      <- get lenerkiezer selection
>   dag      <- get dagv text
>   maand    <- get maandv text
>   jaar     <- get jaarv text
>   leningen <- get leningenvar value
>   case leningen of
>     Nothing  -> do
>       let l = maakLening (Leningen []) bnr lnr (Datum (stringValue dag) (stringValue maand) (stringValue jaar))
>       set leningenvar [value := Just (l)]
>     Just leningen@(Leningen xs) -> do
>       let l = maakLening leningen bnr lnr (Datum (stringValue dag) (stringValue maand) (stringValue jaar))
>       set leningenvar [value := Just (l)]
>   infoDialog f "Info" "Lening is succesvol toegevoegd."
>   repaint f
>   return ()

> updateLeningKiezerHandler :: Choice () -> Panel c -> Var (Maybe Leningen) -> Var (Boeknummer, Lenersnummer) -> IO ()
> updateLeningKiezerHandler kiezer p leningen leninginfo = do
>   selectie   <- get kiezer selection
>   leni       <- get leningen value
>   case leni of
>     Nothing    -> do errorDialog p "Probleem" "Er zijn geen leningen om te verlengen."
>     Just leningen@(Leningen xs) -> do
>       let (bnr, lnr) = (indexToNummers2 selectie (leningNummers2 xs))
>       let mlening = zoekLening leningen bnr lnr
>       case mlening of
>         Nothing    -> do errorDialog p "Probleem" "Er zijn geen leningen om te verlengen."
>         Just (Lening bnr lnr _) -> do
>           set p [visible := True]
>           set leninginfo [value := (bnr, lnr)]

> updateLeningHandler :: Frame b -> TextCtrl a -> TextCtrl a -> TextCtrl a 
>    -> Var (Maybe Leningen) -> Var (Boeknummer, Lenersnummer) -> IO ()
> updateLeningHandler f dagv maandv jaarv leningenvar infovar = do
>   (bnr, lnr) <- get infovar value
>   dag        <- get dagv text
>   maand      <- get maandv text
>   jaar       <- get jaarv text
>   leni       <- get leningenvar value
>   case leni of
>     Nothing    -> do errorDialog f "Probleem" "Er zijn geen leningen om te verlengen."
>     Just leningen@(Leningen xs) -> do
>       let b = wijzigLening leningen bnr lnr (Datum (stringValue dag) (stringValue maand) (stringValue jaar))
>       set leningenvar [value := Just (b)]
>       infoDialog f "Info" "Lening is succesvol verlengd."
>   repaint f
>   return ()

> verwijderLeningHandler :: Choice () -> Frame a -> Var (Maybe Leningen) -> IO ()
> verwijderLeningHandler kiezer f leningenvar = do
>   selectie <- get kiezer selection
>   leni     <- get leningenvar value
>   case leni of
>     Nothing    -> do errorDialog f "Probleem" "Er zijn geen leningen om te verwijderen."
>     Just leningen@(Leningen xs) -> do
>       let (bnr, lnr) = (indexToNummers2 selectie (leningNummers2 xs))
>       let mlening = zoekLening leningen bnr lnr
>       case mlening of
>         Nothing    -> do errorDialog f "Probleem" "Er zijn geen leningen om te verwijderen."
>         Just (Lening bnr lnr _ ) -> do
>           let l = verwijderLening leningen bnr lnr
>           set leningenvar [value := Just (l)]
>           infoDialog f "Info" "Lening is succesvol verwijderd."
>           repaint f

</pre>

</body>
</html>